﻿using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.EvolutionaryTracking {
  public class SymbolicExpressionTreeGenealogyGraph : GenealogyGraph<ISymbolicExpressionTree> {
    public SymbolicExpressionTreeGenealogyGraph() {
    }

    [StorableConstructor]
    public SymbolicExpressionTreeGenealogyGraph(bool serializing)
      : base(serializing) {
    }

    #region Fragment tracing
    public IEnumerable<ISymbolicExpressionTree> TraceFragment(ISymbolicExpressionTreeNode fragment, int mode = 0) {
      //return Keys.Where(tree => ContainsFragment(tree, fragment, mode) != -1);
      return Keys.Where(tree => tree.ContainsFragment(fragment, mode));
    }
    #endregion
  }
}
